//  RungeKutta4.cpp
#include "RungeKutta4.h"

void RungeKutta4::initRK4(int ndim, double dt){
    n = ndim;
    h = dt;
    yn =  vector<double>(n);
    k1 =  vector<double>(n);
    k2 =  vector<double>(n);
    k3 =  vector<double>(n);
    k4 =  vector<double>(n);
}

void RungeKutta4::advanceStep(double t, vector<double>& y){
    rhs(t, y, k1);
    for(int j=0; j<n; j++) yn[j] = y[j] + h*k1[j]/2.0;
    rhs(t+h/2.0, yn, k2);
    for(int j=0; j<n; j++) yn[j] = y[j] + h*k2[j]/2.0;
    rhs(t+h/2.0, yn, k3);
    for(int j=0; j<n; j++) yn[j] = y[j] + h*k3[j];
    rhs(t+h, yn, k4);
    for(int j=0; j<n; j++) y[j] += h*(k1[j] + 2*k2[j] + 2*k3[j] + k4[j])/6.0;
}
