import numpy as np
import math
from scipy.spatial import ConvexHull
import matplotlib.pyplot as plt

npts  = 20
niter = 10
mean  = 0.0

for i in range (niter):
    points = np.zeros((npts,2))
    j = 0
    while j < npts:
        a = 2.0*np.random.rand(1, 2)-1.0
        if np.sum( a**2 )<= 1.0 :
            points[j,:] = a[:,:]
            j = j+1
    hull = ConvexHull(points)
    area = hull.volume/math.pi
    print(area)
    mean = mean + area
mean = mean/niter
print("Mean = %2.5f" % mean)

# plot an example (the last trial)
fig = plt.figure()
ax = fig.add_subplot(111)
plt.xlim([-1,1])
plt.ylim([-1,1])
plt.plot(points[:,0], points[:,1], 'o')
for simplex in hull.simplices:
    plt.plot(points[simplex, 0], points[simplex, 1], 'k-')
c = plt.Circle((0.0,0.0), 1.0, fc="#ccccbb")
ax.add_patch(c)
plt.show()