//
// regula falsi 
//
#include <iostream>
#include <cmath>

using namespace std;
int main()
{
    const double c_total  = 7.87;    // total Ca, in $\mu$M
    const double Bm_total = 290.0;   // total mobile buffer, in $\mu$M
    const double Bf_total = 160.0;   // total fixed buffer, in $\mu$M
    const double E_total  = 100.0;     //100.0; // total EGTA, in $\mu$M

    const double Kd_m = 200.0;       // in $\mu$M
    const double Kd_f  = 2.0;        // in $\mu$M
    const double Kd_E  = 0.07;       // in $\mu$M
    const double cerror = 1.0e-7;

    double c, Bmc, Bfc, Ec;     // free concentration
    double cx;

    int flag = 1;
    double dc = 0.01;
    double cfac = -0.3;
    c = 0.0;
    while(true){
        c += dc;
        Bmc = Bm_total*(1.0 - Kd_m/(c+Kd_m));
        Bfc = Bf_total*(1.0 - Kd_f/(c+Kd_f));
        Ec  = E_total *(1.0 - Kd_E/(c+Kd_E));
        cx  = c + Bmc + Bfc + Ec;
        cout << "c=" << c << ", cx = " << cx << ", dc = " << dc << endl;
        
        if(fabs(c_total - cx )<cerror)break;

        if((flag==1) &&(cx>c_total)){
            dc *= cfac;
            flag = 0;
        }else if((flag==0)&&(cx<c_total)){
            dc *=cfac;
            flag = 1;
        }
    }  
    cout << "Ans: c = " << c << endl;
    return 0;
}
